/*
*  Rubrica
*  file: preview_int.c
*        Build window that will show the content of a .rub file
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * NON MODIFICARE QUESTO FILE - generato automaticamente da Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "preview_cb.h"
#include "preview_int.h"
#include "support.h"


GtkWidget *RubricaPreview;
GtkWidget *RubricaPreviewFs;
gchar *filename;


static GnomeUIInfo file1_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_CLOSE_ITEM (close_preview_cb, NULL),
  GNOMEUIINFO_END
};

/*
static GnomeUIInfo help1_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_ABOUT_ITEM (on_about_preview_activate, NULL),
  GNOMEUIINFO_END
};
*/

static GnomeUIInfo menubar1_uiinfo[] =
{
  GNOMEUIINFO_MENU_FILE_TREE (file1_menu_uiinfo),
//  GNOMEUIINFO_MENU_HELP_TREE (help1_menu_uiinfo),
  GNOMEUIINFO_END
};

GtkWidget*
create_RubricaPreview (void)
{
  GtkWidget *dock1;
  GtkWidget *frame2;
  GtkWidget *vbox2;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *hseparator1;
  GtkWidget *hbuttonbox1;
  GtkWidget *button1;
  GtkWidget *button2;

  GtkWidget *ctree;
  GtkWidget *label;

  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  GtkTooltips *tooltip;

  RubricaPreview = gnome_app_new ("RubricaPreview", _("RubricaPreview"));

  gtk_object_set_data (GTK_OBJECT (RubricaPreview), "RubricaPreview", RubricaPreview);
  gtk_container_set_border_width (GTK_CONTAINER (RubricaPreview), 5);
  gtk_window_set_position (GTK_WINDOW (RubricaPreview), GTK_WIN_POS_CENTER);
  gtk_widget_set_usize (GTK_WIDGET(RubricaPreview), 400, 350);
  gnome_app_enable_layout_config (GNOME_APP (RubricaPreview), FALSE);

  dock1 = GNOME_APP (RubricaPreview)->dock;
  gtk_widget_ref (dock1);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "dock1", dock1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dock1);

  gnome_app_create_menus (GNOME_APP (RubricaPreview), menubar1_uiinfo);

  gtk_widget_ref (menubar1_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "file1",
                            menubar1_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "chiudi1",
                            file1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

/*
  gtk_widget_ref (menubar1_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "help1",
                            menubar1_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "about1",
                            help1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);
*/

  frame2 = gtk_frame_new (_(" Rubrica Preview "));
  gnome_app_set_contents (GNOME_APP (RubricaPreview), frame2);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);
  gtk_widget_show (frame2);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame2), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 5);
  gtk_widget_show (vbox2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 5);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), 
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrolledwindow1);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);
  gtk_widget_show (viewport1);

  /* Gtk CTree */
  ctree = gtk_ctree_new (2,0);
  gtk_widget_ref (ctree);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "ctree", ctree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (viewport1), ctree);
  gtk_container_set_border_width (GTK_CONTAINER (ctree), 0);
  gtk_clist_column_titles_show(GTK_CLIST (ctree));
  gtk_clist_set_column_width (GTK_CLIST (ctree), 0, 150);
  gtk_clist_set_column_width (GTK_CLIST (ctree), 0, 150);
  gtk_widget_show (ctree);

  label = gtk_label_new ("");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (ctree), 0, label);

  label = gtk_label_new ("");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (ctree), 1, label);

  hseparator1 = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox2), hseparator1, FALSE, TRUE, 5);
  gtk_widget_show (hseparator1);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_box_pack_start (GTK_BOX (vbox2), hbuttonbox1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox1), 3);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_END);
  gtk_widget_show (hbuttonbox1);

  button1 = gtk_button_new_with_label (_("Open"));
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "preview_open", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
  gtk_widget_show (button1);

  button2 = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreview), "preview_close", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button2);
  GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
  gtk_widget_show (button2);

  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip(GTK_TOOLTIPS(tooltip), button1, 
		       _("Open the previewed file in rubrica"), NULL);

  /* File selection */
  RubricaPreviewFs = gtk_file_selection_new (_("Rubrica Preview file selection"));
  gtk_object_set_data (GTK_OBJECT (RubricaPreviewFs), "RubricaPreviewFs", 
		       RubricaPreviewFs);
  gtk_container_set_border_width (GTK_CONTAINER (RubricaPreviewFs), 10);
  GTK_WINDOW (RubricaPreviewFs)->type = GTK_WINDOW_DIALOG;
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (RubricaPreviewFs));

  ok_button1 = GTK_FILE_SELECTION (RubricaPreviewFs)->ok_button;
  gtk_object_set_data (GTK_OBJECT (RubricaPreviewFs), "ok_button1", ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);
  gtk_widget_show (ok_button1);

  cancel_button1 = GTK_FILE_SELECTION (RubricaPreviewFs)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (RubricaPreviewFs), "cancel_button1",
		       cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);
  gtk_widget_show (cancel_button1);

  gtk_widget_show(RubricaPreviewFs);

  /* Callback's Signals */
  gtk_signal_connect (GTK_OBJECT (RubricaPreview), "delete_event",
                      GTK_SIGNAL_FUNC (close_preview_cb),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_open_preview_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked",
                      GTK_SIGNAL_FUNC (close_preview_cb),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (RubricaPreviewFs), "delete_event",
                      GTK_SIGNAL_FUNC (close_preview_cb),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cancel_button1), "clicked",
                      GTK_SIGNAL_FUNC (close_preview_cb),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (ok_button1), "clicked",
                      GTK_SIGNAL_FUNC (load_preview_cb),
                      RubricaPreviewFs);


  return RubricaPreview;
}


GtkWidget *rubrica_preview_get_window()
{
  return GTK_WIDGET(RubricaPreview);
}

GtkWidget *rubrica_preview_get_file_selection()
{
  return GTK_WIDGET(RubricaPreviewFs);
}

void rubrica_preview_set_filename(gchar *file)
{
  if(filename)
    g_free(filename);

  filename = g_strdup(file);
}

gchar *rubrica_preview_get_filename(void)
{
  return (gchar*) filename;
}

      
